//
// named.conf
//
{{ ansible_managed | comment('c') }}
//
{% for acl in glxclans_dns_acls %}
acl "{{ acl.name }}" {
{% for match in acl.match_list %}
  {{ match }};
{% endfor %}
};
{% endfor %}

{% for _current_key in glxclans_dns_tsig_keys %}
// KEY -- _current_key.name
include "{{ __glxclans_dns_conf_dir }}/keys/{{ _current_key.name }}.conf";
{% endfor %}

options {
  {% if glxclans_dns_listen_ipv4 is defined and glxclans_dns_listen_ipv4 | length > 0 %}
  listen-on port 53 { {{ glxclans_dns_listen_ipv4|join('; ') }}; };
  {% endif %}
  {% if glxclans_dns_listen_ipv6 is defined and glxclans_dns_listen_ipv6 | length > 0 %}
  listen-on-v6 port 53 { {{ glxclans_dns_listen_ipv6|join('; ') }}; };
  {% endif %}
  directory   "{{ __glxclans_dns_basedir }}";
  dump-file   "{{ __glxclans_dns_basedir }}/data/cache_dump.db";
  statistics-file "{{ __glxclans_dns_basedir }}/data/named_stats.txt";
  memstatistics-file "{{ __glxclans_dns_basedir }}/data/named_mem_stats.txt";
  allow-query     { {{ glxclans_dns_allow_query|join('; ') }}; };
  allow-transfer  { none; };
  version none;
{% if glxclans_dns_check_names is defined %}
  check-names  {{ glxclans_dns_check_names }};
{% endif %}

  recursion {% if glxclans_dns_recursion|bool %}yes{% else %}no{% endif %};
  {% if glxclans_dns_recursion %}allow-recursion { {{ glxclans_dns_allow_recursion|join('; ') }}; };
  {% endif %}
{% if glxclans_dns_forwarders|length > 0 %}forwarders { {{ glxclans_dns_forwarders|join('; ') }}; };{% endif %}
  {% if glxclans_dns_forward_only %}forward only;{% endif %}

  rrset-order { order {{ glxclans_dns_rrset_order }}; };

  dnssec-validation {{ glxclans_dns_dnssec_validation }};

  /* Path to ISC DLV key */
  bindkeys-file "/etc/named.iscdlv.key";

  managed-keys-directory "{{ __glxclans_dns_basedir }}/dynamic";

  pid-file "/run/named/named.pid";
  session-keyfile "/run/named/session.key";
{% if bind_query_log is defined %}

  querylog yes;
{% endif %}
};

{% if glxclans_dns_statistics_channels %}
statistics-channels {
  inet {{ glxclans_dns_statistics_host }} port {{ glxclans_dns_statistics_port }} allow { {{ glxclans_dns_statistics_allow|join('; ') }}; };
};
{% endif %}

logging {
  channel default_debug {
    file "{{ __glxclans_dns_log_file }}";
    severity dynamic;
    print-time yes;
  };
{% if bind_query_log is defined %}
  channel querylog {
    file "{{ bind_query_log }}" versions 600 size 20m;
    severity dynamic;
    print-time yes;
  };
  category queries { querylog; };
{% endif %}
{% if bind_other_logs is defined %}

{% for log in bind_other_logs %}
  channel {{ log.name }} {
    file "{{ log.file }}" versions {{ log.versions }} size {{ log.size }};
    severity dynamic;
    print-time yes;
  };
  category "{{ log.name }}" { "{{ log.name }}"; };
{% endfor %}
{% endif %}
};


view default {
{% set _current_view = 'default' %}
{% if __glxclans_dns_default_view.match_clients is defined %}
  match-clients { {{ __glxclans_dns_default_view.match_clients | join('; ') }}; };
{% endif %}
{% for file in __glxclans_dns_default_zone_files %}
  include "{{ file }}";
{% endfor %}
{% for file in glxclans_dns_extra_include_files %}
  include "{{ file }}";
{% endfor %}
{% if __glxclans_dns_forward_zone_domains is defined %}
// --- FORWARD ZONES ---
{%   include 'named_parts/_forward_zone.j2' %}
// --- MASTER ZONES ---
{%   include 'named_parts/_master_zone.j2' %}
// --- SLAVE ZONES ---
{%   include 'named_parts/_slave_zone.j2' %}
{% endif %}
};

{% for _current_bind_view in __glxclans_dns_non_default_views %}
{% set _current_view = _current_bind_view.name %}
view {{ _current_bind_view.name }} {
{% if _current_bind_view.match_clients is defined %}
  match-clients { {{ _current_bind_view.match_clients | join('; ') }}; };
{% endif %}
{% if __glxclans_dns_forward_zone_domains is defined %}
// --- FORWARD ZONES ---
{%   include 'named_parts/_forward_zone.j2' %}
// --- MASTER ZONES ---
{%   include 'named_parts/_master_zone.j2' %}
// --- SLAVE ZONES ---
{%   include 'named_parts/_slave_zone.j2' %}
{% endif %}
};
{% endfor %}
